<template>
  <div>
    <el-form ref="arrivalForm" :rules="rules" :model="airArrivalInfo" label-width="120px">
     <el-form-item :label="$t('到港情况')" prop="arriveType">
        <el-radio-group v-model="airArrivalInfo.arriveType">
          <el-radio :label="0">{{ $t('一次到港') }}</el-radio>
          <el-radio :label="1">{{ $t('多次到港') }}</el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item :label="$t('选择订单')" prop="arriveOrderIdList" v-show="airArrivalInfo.arriveType == 1">
        <el-select
          v-model="airArrivalInfo.arriveOrderIdList"
          multiple
          filterable
          clearable
          reserve-keyword
          :filter-method="filterOrder"
          :placeholder="$t('请输入订单号、提单号、唛头')"
           @change="selectOrderId"
          >
            <el-option
            v-for="(item) in statusOrderList"
            :key="item.orderId"
            :label="item.orderNo+' '+item.arrival"
            :value="item.orderId">
            </el-option>
        </el-select>
      </el-form-item>
      <el-form-item :label="$t('已到港订单')" v-show="airArrivalInfo.arriveType == 1">
        <span v-for="order in airArrivalInfo.arrivalOrderList" :key="order.id">{{order.orderNo}} </span>
      </el-form-item>

      <el-form-item v-if="dtRealHeadTimeFlag||airArrivalInfo.arriveType==1" :label="$t('实际二程起飞时间')" prop="actSecondTime">
        <template slot="label" slot-scope="scope">
            <span style="color: red;">*</span>{{$t('实际二程起飞时间')}} 
        </template>
        <el-date-picker type="datetime" :placeholder="$t('请选择日期')" v-model="airArrivalInfo.actSecondTime" value-format="yyyy-MM-dd HH:mm:ss"></el-date-picker>
      </el-form-item>
      <el-form-item :label="$t('预计到港时间')" prop="estTime">
        <el-date-picker type="datetime" :placeholder="$t('请选择日期')" v-model="airArrivalInfo.estTime" value-format="yyyy-MM-dd HH:mm:ss"></el-date-picker>
      </el-form-item>
      <el-form-item :label="$t('实际到港时间')" prop="actTime">
        <template slot="label" slot-scope="scope">
            <span style="color: red;">*</span>{{$t('实际到港时间')}} 
        </template>
        <el-date-picker type="datetime" :placeholder="$t('请选择日期')" v-model="airArrivalInfo.actTime" value-format="yyyy-MM-dd HH:mm:ss"></el-date-picker>
      </el-form-item>

    </el-form>

    <el-row class="operate-button">
      <el-button type="primary" @click="onSubmit(1)">{{$t('保存')}}</el-button>
      <el-button type="success" @click="onSubmit(2)">{{$t('提交')}}</el-button>
      <el-button @click="cancel">{{$t('关闭')}}</el-button>
      <el-button type="primary" @click="exceptionReg" :disabled="!showMsg">{{$t('异常登记')}}</el-button>
    </el-row>

    <!-- 对话框 -->
    <el-dialog custom-class="shipping-dialog" :title="$t('票异常')" :visible.sync="dialogVisible" width="700px" :modal-append-to-body=false append-to-body destroy-on-close>
      <regError @closeDialog="regCloseDialog" v-bind="$attrs" />
    </el-dialog>
  </div>
</template>

<script>
import regError from "../../regError";
import dayjs from "dayjs";
import { arrivalCreate } from "@/api/ecw/boxSeaAir";
import { shipmentOrderList } from "@/api/ecw/boxAir";
import { formatDateStr, serviceMsg, formatDate } from "../utils";

/**
 * 到港
 */
export default {
  name: "arrival",
  inheritAttrs: false,
  components: {
    regError,
  },
  data() {
    var validateActSecondTime = (rule, value, callback) => {
      if(!value && (this.airArrivalInfo.arriveType==0||(this.airArrivalInfo.arriveType==1&&this.airArrivalInfo.arriveOrderIdList.length>0))){
        callback(new Error("必填"));
      }
      callback();
    };
    var validateActTime = (rule, value, callback) => {
      if(!value && (this.airArrivalInfo.arriveType==0||(this.airArrivalInfo.arriveType==1&&this.airArrivalInfo.arriveOrderIdList.length>0))){
        callback(new Error("必填"));
      }
      callback();
    };
    return {
      // 到港对象
      airArrivalInfo: {},
      // 校验
      rules: {
        actSecondTime: [
          { validator: validateActSecondTime, trigger: "change" },
        ],
        actTime: [
          { validator: validateActTime, trigger: "change" },
        ]
      },
      // 弹窗配置
      dialogVisible: false,
      // 提示消息
      showMsg: false,
      inspectionTimeArrival: this.getDictDatas(
        this.DICT_TYPE.BOX_INSPECTION_TIME_ARRIVAL
      )[0].value,
      dtRealHeadTimeFlag: false,
      orderList: [],
      orderListFilter: [],
      arrivalOrderList: []
    };
  },
  created() {
    const voName = this.$attrs.currNode.voName;
    let oldData = { ...this.$attrs.shipmentObj[voName] };
    oldData = formatDateStr(
      oldData,
      ["actSecondTime", "estTime", "actTime"],
      "YYYY-MM-DD HH:mm:ss"
    );
    this.airArrivalInfo = oldData;
    if(this.$attrs.shipmentObj['bookAirInfo'].voyage && this.$attrs.shipmentObj['bookAirInfo'].voyage == 2){
      this.dtRealHeadTimeFlag = true
    }
    if(!this.airArrivalInfo.arriveType) this.$set(this.airArrivalInfo,'arriveType',0)
    this.$set(this.airArrivalInfo,'arriveOrderIdList',[])
    this.arrivalOrderList = this.$attrs.shipmentObj.airArrivalInfo?this.$attrs.shipmentObj.airArrivalInfo.arrivalOrderList:[]
    shipmentOrderList(this.$attrs.shipmentObj.id).then(r=>{
      this.orderList = r.data
      this.orderListFilter = r.data
    })
  },
  computed: {
    statusOrderList(){
      let data = []
      this.orderListFilter.forEach(item=>{
        let json = {
            orderId: item.orderId,
            orderNo: item.orderNo,
            tidanNo: item.tidanNo,
            marks: item.marks,
          }
        let index = this.arrivalOrderList?this.arrivalOrderList.findIndex(p=>p.orderId==item.orderId):-1
        if(index != -1){
          json.arrival = this.$t('已到港')
        }else{
          json.arrival = this.$t('未到港')
        }
        data.push(json)
      })
      return data
    }
  },
  watch: {
    // 实际二程起飞时间
    "airArrivalInfo.actSecondTime"(val) {
      this.compareDate(this.getHeadTravelTime(), val);
    },

    "airArrivalInfo.estTime"(val) {
      this.compareDate(this.airArrivalInfo.actTime, val);
    },

    "airArrivalInfo.actTime"(val) {
      this.compareDate(this.airArrivalInfo.estTime, val);
    },

    "airArrivalInfo.arriveType"(val) {
      if(val == 1){
        this.$set(this.airArrivalInfo, 'actSecondTime', null)
        this.$set(this.airArrivalInfo, 'estTime', null)
        this.$set(this.airArrivalInfo, 'actTime', null)
      }else{
        let oldData = { ...this.$attrs.shipmentObj[this.$attrs.currNode.voName] };
        oldData = formatDateStr(
          oldData,
          ["actSecondTime", "estTime", "actTime"],
          "YYYY-MM-DD HH:mm:ss"
        );
        this.$set(this.airArrivalInfo, 'actSecondTime', oldData.actSecondTime)
        this.$set(this.airArrivalInfo, 'estTime', oldData.estTime)
        this.$set(this.airArrivalInfo, 'actTime', oldData.actTime)
      }
    }
  },
  methods: {
    filterOrder(val){
      if(val != ''){
        this.orderListFilter = this.orderList.filter(item=>{
          return item.orderNo&&item.orderNo.indexOf(val) > -1 || item.tidanNo&&item.tidanNo.indexOf(val) > -1 || item.marks&&item.marks.indexOf(val) > -1
        })
      }else{
        this.orderListFilter = this.orderList
      }
    },
    selectOrderId(val) {
      if (val.length == 1) {
        let arr = this.arrivalOrderList.find((item) => item.orderId == val[0])
        if (arr) {
          this.$set(this.airArrivalInfo, 'actSecondTime', formatDate(arr.actSecondTime))
          this.$set(this.airArrivalInfo, 'estTime', formatDate(arr.estTime))
          this.$set(this.airArrivalInfo, 'actTime', formatDate(arr.actTime))
        }
      } else {
        this.$set(this.airArrivalInfo, 'actSecondTime', null)
        this.$set(this.airArrivalInfo, 'estTime', null)
        this.$set(this.airArrivalInfo, 'actTime', null)
      }
    },
    regCloseDialog(type) {
      this.dialogVisible = false;
      if (type === "error") {
        this.$emit("getBoxInfo");
      }
    },
    // 获取实际二程起飞时间
    getHeadTravelTime() {
      const { shippingInfo } = this.$attrs.shipmentObj;
      if (shippingInfo) {
        return dayjs(shippingInfo.realHeadTravelTime).format(
          "YYYY-MM-DD HH:mm:ss"
        );
      }
      return null;
    },
    // 获取预计到港时间
    getExpectedTime() {
      const { shippingInfo } = this.$attrs.shipmentObj;
      if (shippingInfo) {
        return dayjs(shippingInfo.dtEstArrivalTime).format(
          "YYYY-MM-DD HH:mm:ss"
        );
      }
      return null;
    },
    // 时间比较
    compareDate(expectedTime, apConfirmTime) {
      this.showMsg = false;
      let date1 = null,
        date2 = null;
      if (expectedTime) date1 = dayjs(expectedTime);
      if (apConfirmTime) date2 = dayjs(apConfirmTime);
      if (date1 && date2) {
        const days = date2.diff(date1, "day");
        if (days > this.inspectionTimeArrival) {
          this.showMsg = true;
        }
      }
    },
    // 异常登记
    exceptionReg() {
      this.dialogVisible = true;
    },
    /** 提交 */
    onSubmit(operateType) {
      this.$refs["arrivalForm"].validate((valid) => {
        if (valid) {
          arrivalCreate({
            ...this.airArrivalInfo,
            shipmentId: this.$attrs.shipmentObj.id,
            operateType,
          }).then((res) => {
            serviceMsg(res, this).then(() => {
              this.cancel("submit");
            });
          });
        }
      });
    },
    /** 取消 */
    cancel(type) {
      this.$emit("closeDialog", type);
    },
  },
};
</script>

<style lang="scss" scoped>
.message-area {
  margin: 0;
  color: red;
}
</style>
